// ------------------------------------------------------------------------------ GetJFData_quaterRA
// This code create the variable monthsinQ0 which identifies the months in Q0 i.e. the RA quarter.
//	
// 
// This code take as inputs open data set.
// 
// Last Revision: 09/03/2015
//-------------------------------------------------------------------------------------------------------------------------------










//-------------------------------------------------
// How are AFDC grant amounts aggregated into quarters by MDRC?
// We have their variable adcq0 which is described as "afdc payment ra quarter"
// We try to reconstruct it by adding AFDC monthly amounts in tree definitions of Q of RA:
//	a. {-2,-1,0}
//	b. {-1,0,1}
//	c. {0,1,2}
//-------------------------------------------------
local ass "adc"


qui gen `ass'q0_a = `ass'pm2 +`ass'pm1 +`ass'm0
qui gen `ass'q0_b = `ass'pm1 +`ass'm0 +`ass'm1
qui gen `ass'q0_c = `ass'm0 +`ass'm1+ `ass'm2

qui gen n`ass'q0_a = (`ass'pm2~=0) + (`ass'pm1~=0) + (`ass'm0~=0)
qui gen n`ass'q0_b = (`ass'pm1~=0) + (`ass'm0~=0) +(`ass'm1~=0)
qui gen n`ass'q0_c = (`ass'm0~=0) + (`ass'm1~=0)+ (`ass'm2~=0)

foreach j in a b c {
	qui gen ind_`ass'q0_`j' = (`ass'q0_`j'==`ass'q0)
	tab ind_`ass'q0_`j'  		if applcant==0&`ass'm0==0
	tab ind_`ass'q0_`j'  		if applcant==0&`ass'm0>0
	reg `ass'q0_`j' `ass'q0 	if applcant==0
}
qui gen ind_`ass'q0 = "a" 	if ind_`ass'q0_a==1
qui replace ind_`ass'q0 = ind_`ass'q0+";"+"b" if ind_`ass'q0_b==1&ind_`ass'q0~=""
qui replace ind_`ass'q0 = "b" if ind_`ass'q0_b==1&ind_`ass'q0==""
qui replace ind_`ass'q0 = ind_`ass'q0+";"+"c" if ind_`ass'q0_c==1&ind_`ass'q0~=""
qui replace ind_`ass'q0 = "c" if ind_`ass'q0_c==1&ind_`ass'q0==""
tab ind_`ass'q0 quarterRA 	if applcant==0, missing 

assert ind_`ass'q0~="c" if `ass'pq8==.
assert ind_`ass'q0~="a"&ind_`ass'q0~="b"&ind_`ass'q0~="a;b" if `ass'pq8~=.

qui gen finalqa = "c" if `ass'pq8~=. // this is for sure the RA-Q months {0,1,2}
qui replace finalqa = "b" if `ass'pq8==.&(ind_`ass'q0=="b"|ind_`ass'q0=="b;c") // this is for sure the RA-Q months {-1,0,1}
qui replace finalqa = "a" if `ass'pq8==.&(ind_`ass'q0=="a"|ind_`ass'q0=="a;c") // this is for sure the RA-Q months {-2,-1,0}
qui gen qfinalqa = 0 if finalqa~="" // quater on which we based the assignment of the methodology

tab finalqa ind_`ass'q0, missing






capture program drop update_finalqa
capture program define update_finalqa
	args q ass
	foreach j in a b c {
		qui gen ind_`ass'q`q'_`j' = (`ass'q`q'_`j'==`ass'q`q')
	}
	qui gen ind_`ass'q`q' = "a" 	if ind_`ass'q`q'_a==1
	qui replace ind_`ass'q`q' = ind_`ass'q`q'+";"+"b" if ind_`ass'q`q'_b==1&ind_`ass'q`q'~=""
	qui replace ind_`ass'q`q' = "b" if ind_`ass'q`q'_b==1&ind_`ass'q`q'==""
	qui replace ind_`ass'q`q' = ind_`ass'q`q'+";"+"c" if ind_`ass'q`q'_c==1&ind_`ass'q`q'~=""
	qui replace ind_`ass'q`q' = "c" if ind_`ass'q`q'_c==1&ind_`ass'q`q'==""

	qui gen one = (ind_`ass'q`q'=="a"|ind_`ass'q`q'=="a;b"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="a;c")
	capture assert one==1   if finalqa=="a" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology A.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="a"&one==0
		pause 
	}
	qui replace one = (ind_`ass'q`q'=="b"|ind_`ass'q`q'=="a;b"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="b;c")
	capture assert  one==1  if finalqa=="b" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology B.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="b"&one==0
		pause 
	}
	qui replace one = (ind_`ass'q`q'=="c"|ind_`ass'q`q'=="a;c"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="b;c")
	capture assert one==1   if finalqa=="c" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology C.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="c"&one==0
		pause 
	}	
	qui replace one = (ind_`ass'q`q'~="c")
	capture assert one==1 if finalqa=="" // can only be a or b not c
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously un-assigned:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="c"&one==0
		pause
	}	
	
	tab ind_`ass'q`q' ind_`ass'q0 if finalqa=="" // can we pin it down?
	qui gen temp = finalqa
	qui replace finalqa = "b" if `ass'pq8==.&(ind_`ass'q`q'=="b"|ind_`ass'q`q'=="b;c") // this is for sure the RA-Q months {-1,0,1}
	qui replace finalqa = "a" if `ass'pq8==.&(ind_`ass'q`q'=="a"|ind_`ass'q`q'=="a;c") // this is for sure the RA-Q months {-2,-1,0}
	qui replace qfinalqa = `q' if finalqa~=""&temp=="" // quater on which we based the assignment of the methodology
	drop temp
	drop one
	drop `ass'q`q'_*
	drop ind_`ass'q`q'_*
	rename ind_`ass'q`q' ind_`ass'q_post`q'
end 




capture program drop update_finalqa_v2
capture program define update_finalqa_v2
	args q ass
	foreach j in a b c {
		qui gen ind_`ass'q`q'_`j' = (`ass'q`q'_`j'==`ass'pq`q')
	}
	qui gen ind_`ass'q`q' = "a" 	if ind_`ass'q`q'_a==1
	qui replace ind_`ass'q`q' = ind_`ass'q`q'+";"+"b" if ind_`ass'q`q'_b==1&ind_`ass'q`q'~=""
	qui replace ind_`ass'q`q' = "b" if ind_`ass'q`q'_b==1&ind_`ass'q`q'==""
	qui replace ind_`ass'q`q' = ind_`ass'q`q'+";"+"c" if ind_`ass'q`q'_c==1&ind_`ass'q`q'~=""
	qui replace ind_`ass'q`q' = "c" if ind_`ass'q`q'_c==1&ind_`ass'q`q'==""

	qui gen one = (ind_`ass'q`q'=="a"|ind_`ass'q`q'=="a;b"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="a;c")
	capture assert one==1   if finalqa=="a" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology A.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="a"&one==0
		pause 
	}
	qui replace one = (ind_`ass'q`q'=="b"|ind_`ass'q`q'=="a;b"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="b;c")
	capture assert  one==1  if finalqa=="b" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology B.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="b"&one==0
		pause 
	}
	qui replace one = (ind_`ass'q`q'=="c"|ind_`ass'q`q'=="a;c"|ind_`ass'q`q'=="a;b;c"|ind_`ass'q`q'=="b;c")
	capture assert one==1   if finalqa=="c" // still fine?
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously assigned to methodology C.:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="c"&one==0
		pause 
	}	
	qui replace one = (ind_`ass'q`q'~="c")
	capture assert one==1 if finalqa=="" // can only be a or b not c
	if _rc~=0 {
		di "Contradiction when using quarter `q' for a case previously un-assigned:"
		tab ind_`ass'q`q' qfinalqa if finalqa=="c"&one==0
		pause
	}	
	
	*tab ind_`ass'q`q' ind_`ass'q0 if finalqa=="" // can we pin it down? sometimes yes
	qui gen temp = finalqa
	qui replace finalqa = "b" if `ass'pq8==.&(ind_`ass'q`q'=="b"|ind_`ass'q`q'=="b;c") // this is for sure the RA-Q months {-1,0,1}
	qui replace finalqa = "a" if `ass'pq8==.&(ind_`ass'q`q'=="a"|ind_`ass'q`q'=="a;c") // this is for sure the RA-Q months {-2,-1,0}
	qui replace qfinalqa = -`q' if finalqa~=""&temp=="" // quater on which we based the assignment of the methodology
	drop temp
	drop one
	drop `ass'q`q'_*
	drop ind_`ass'q`q'_*
	rename ind_`ass'q`q' ind_`ass'q_prior`q'
end 



// let us generalize this to pin down the Q-RA for the cases when ind_`ass'q0 is a;b;c   or    a;c
pause on
local q=1
qui gen `ass'q`q'_a = `ass'm1 +`ass'm2 +`ass'm3
qui gen `ass'q`q'_b = `ass'm2 +`ass'm3 +`ass'm4
qui gen `ass'q`q'_c = `ass'm3 +`ass'm4 +`ass'm5
update_finalqa `q' `ass' 

local q=2
qui gen `ass'q`q'_a = `ass'm4 +`ass'm5 +`ass'm6
qui gen `ass'q`q'_b = `ass'm5 +`ass'm6+`ass'm7
qui gen `ass'q`q'_c = `ass'm6+`ass'm7+`ass'm8
update_finalqa `q' `ass' 

local q=3
qui gen `ass'q`q'_a = `ass'm7 +`ass'm8 +`ass'm9
qui gen `ass'q`q'_b = `ass'm8 +`ass'm9 +`ass'm10
qui gen `ass'q`q'_c = `ass'm9 +`ass'm10 +`ass'm11
update_finalqa `q' `ass' 

local q=4
qui gen `ass'q`q'_a = `ass'm10 +`ass'm11 +`ass'm12
qui gen `ass'q`q'_b = `ass'm11 +`ass'm12 +`ass'm13
qui gen `ass'q`q'_c = `ass'm12 +`ass'm13 +`ass'm14
update_finalqa `q' `ass' 

local q=5
qui gen `ass'q`q'_a = `ass'm13 +`ass'm14 +`ass'm15
qui gen `ass'q`q'_b = `ass'm14 +`ass'm15 +`ass'm16
qui gen `ass'q`q'_c = `ass'm15 +`ass'm16 +`ass'm17
update_finalqa `q' `ass'


local q=6
qui gen `ass'q`q'_a = `ass'm16 +`ass'm17 +`ass'm18
qui gen `ass'q`q'_b = `ass'm17 +`ass'm18 +`ass'm19
qui gen `ass'q`q'_c = `ass'm18 +`ass'm19 +`ass'm20
update_finalqa `q' `ass'


local q=7
qui gen `ass'q`q'_a = `ass'm19 +`ass'm20 +`ass'm21
qui gen `ass'q`q'_b = `ass'm20 +`ass'm21 +`ass'm22
qui gen `ass'q`q'_c = `ass'm21 +`ass'm22 +`ass'm23
update_finalqa `q' `ass'

local q=8
qui gen `ass'q`q'_a = `ass'm22 +`ass'm23 +`ass'm24
qui gen `ass'q`q'_b = `ass'm23 +`ass'm24 +`ass'm25
qui gen `ass'q`q'_c = `ass'm24 +`ass'm25 +`ass'm26
update_finalqa `q' `ass'

local q=9
qui gen `ass'q`q'_a = `ass'm25 +`ass'm26 +`ass'm27
qui gen `ass'q`q'_b = `ass'm26 +`ass'm27 +`ass'm28
qui gen `ass'q`q'_c = `ass'm27 +`ass'm28 +`ass'm29
update_finalqa `q' `ass'

local q=10
qui gen `ass'q`q'_a = `ass'm28 +`ass'm29 +`ass'm30
qui gen `ass'q`q'_b = `ass'm29 +`ass'm30 +`ass'm31
qui gen `ass'q`q'_c = `ass'm30 +`ass'm31 +`ass'm32
update_finalqa `q' `ass'

local q=11
qui gen `ass'q`q'_a = `ass'm31 +`ass'm32 +`ass'm33
qui gen `ass'q`q'_b = `ass'm32 +`ass'm33 +`ass'm34
qui gen `ass'q`q'_c = `ass'm33 +`ass'm34 +`ass'm35
update_finalqa `q' `ass'

local q=12
qui gen `ass'q`q'_a = `ass'm34 +`ass'm35 +`ass'm36
qui gen `ass'q`q'_b = `ass'm35 +`ass'm36 +`ass'm37
qui gen `ass'q`q'_c = `ass'm36 +`ass'm37 +`ass'm38
update_finalqa `q' `ass'

local q=13
qui gen `ass'q`q'_a = `ass'm37 +`ass'm38 +`ass'm39
qui gen `ass'q`q'_b = `ass'm38 +`ass'm39 +`ass'm40
qui gen `ass'q`q'_c = `ass'm39 +`ass'm40 +`ass'm41
update_finalqa `q' `ass'

local q=14
qui gen `ass'q`q'_a = `ass'm40 +`ass'm41 +`ass'm42
qui gen `ass'q`q'_b = `ass'm41 +`ass'm42 +`ass'm43
qui gen `ass'q`q'_c = `ass'm42 +`ass'm43 +`ass'm44
update_finalqa `q' `ass'

local q=15
qui gen `ass'q`q'_a = `ass'm43 +`ass'm44 +`ass'm45
qui gen `ass'q`q'_b = `ass'm44 +`ass'm45 +`ass'm46
qui gen `ass'q`q'_c = `ass'm45 +`ass'm46 +`ass'm47
update_finalqa `q' `ass'


local q=16
qui gen `ass'q`q'_a = `ass'm46 +`ass'm47 +`ass'm48
qui gen `ass'q`q'_b = `ass'm47 +`ass'm48 +`ass'm49
qui gen `ass'q`q'_c = `ass'm48 +`ass'm49 +`ass'm50
update_finalqa `q' `ass'


local q=17
qui gen `ass'q`q'_a = `ass'm49 +`ass'm50 +`ass'm51
qui gen `ass'q`q'_b = `ass'm50 +`ass'm51 +`ass'm52
qui gen `ass'q`q'_c = `ass'm51 +`ass'm52 +`ass'm53
update_finalqa `q' `ass'

local q=18
qui gen `ass'q`q'_a = `ass'm52 +`ass'm53 +`ass'm54
qui gen `ass'q`q'_b = `ass'm53 +`ass'm54 +`ass'm55
qui gen `ass'q`q'_c = `ass'm54 +`ass'm55 +`ass'm56
update_finalqa `q' `ass'


local q=19
qui gen `ass'q`q'_a = `ass'm55 +`ass'm56 +`ass'm57
qui gen `ass'q`q'_b = `ass'm56 +`ass'm57 +`ass'm58
qui gen `ass'q`q'_c = `ass'm57 +`ass'm58 +`ass'm59
update_finalqa `q' `ass'

local q=20
qui gen `ass'q`q'_a = `ass'm58 +`ass'm59 +`ass'm60
qui gen `ass'q`q'_b = `ass'm59 +`ass'm60 +`ass'm61
qui gen `ass'q`q'_c = `ass'm60 +`ass'm61 +`ass'm62
update_finalqa `q' `ass'

local q=21
qui gen `ass'q`q'_a = `ass'm61 +`ass'm62 +`ass'm63
qui gen `ass'q`q'_b = `ass'm62 +`ass'm63 +`ass'm64
qui gen `ass'q`q'_c = `ass'm63 +`ass'm63 +`ass'm65
update_finalqa `q' `ass'

// we start using also prior to RA
local pq = 1
qui gen `ass'q`pq'_a = `ass'pm5 +`ass'pm4 +`ass'pm3
qui gen `ass'q`pq'_b = `ass'pm4 +`ass'pm3 +`ass'pm2
qui gen `ass'q`pq'_c = `ass'pm3 +`ass'pm2 +`ass'pm1
update_finalqa_v2 `pq' `ass'

local pq = 2
qui gen `ass'q`pq'_a = `ass'pm8 +`ass'pm7 +`ass'pm6
qui gen `ass'q`pq'_b = `ass'pm7 +`ass'pm6 +`ass'pm5
qui gen `ass'q`pq'_c = `ass'pm6 +`ass'pm5 +`ass'pm4
update_finalqa_v2 `pq' `ass'

local pq = 3
qui gen `ass'q`pq'_a = `ass'pm11 +`ass'pm10 +`ass'pm9
qui gen `ass'q`pq'_b = `ass'pm10 +`ass'pm9 +`ass'pm8
qui gen `ass'q`pq'_c = `ass'pm9 +`ass'pm8 +`ass'pm7
update_finalqa_v2 `pq' `ass'


local pq = 4
qui gen `ass'q`pq'_a = `ass'pm14 +`ass'pm13 +`ass'pm12
qui gen `ass'q`pq'_b = `ass'pm13 +`ass'pm12 +`ass'pm11
qui gen `ass'q`pq'_c = `ass'pm12 +`ass'pm11 +`ass'pm10
update_finalqa_v2 `pq' `ass'

local pq = 5
qui gen `ass'q`pq'_a = `ass'pm17 +`ass'pm16 +`ass'pm15
qui gen `ass'q`pq'_b = `ass'pm16 +`ass'pm15 +`ass'pm14
qui gen `ass'q`pq'_c = `ass'pm15 +`ass'pm14 +`ass'pm13
update_finalqa_v2 `pq' `ass'

local pq = 6
qui gen `ass'q`pq'_a = `ass'pm20 +`ass'pm19 +`ass'pm18
qui gen `ass'q`pq'_b = `ass'pm19 +`ass'pm18 +`ass'pm17
qui gen `ass'q`pq'_c = `ass'pm18 +`ass'pm17 +`ass'pm16
update_finalqa_v2 `pq' `ass'

local pq = 7
qui gen `ass'q`pq'_a = `ass'pm23 +`ass'pm22 +`ass'pm21
qui gen `ass'q`pq'_b = `ass'pm22 +`ass'pm21 +`ass'pm20
qui gen `ass'q`pq'_c = `ass'pm21 +`ass'pm20 +`ass'pm19
update_finalqa_v2 `pq' `ass'



rename finalqa finalqa_basedonAFDC
rename qfinalqa qfinalqa_basedonAFDC
tab finalqa_basedonAFDC qfinalqa_basedonAFDC,  missing


//-------------------------------------------------
// How are FS grant amounts aggregated into quarters by MDRC?
// We have their variable adcq0 which is described as "afdc payment ra quarter"
// We try to reconstruct it by adding AFDC monthly amounts in tree definitions of Q of RA:
//	a. {-2,-1,0}
//	b. {-1,0,1}
//	c. {0,1,2}
//-------------------------------------------------
local ass "fst"


qui gen `ass'q0_a = `ass'pm2 +`ass'pm1 +`ass'm0
qui gen `ass'q0_b = `ass'pm1 +`ass'm0 +`ass'm1
qui gen `ass'q0_c = `ass'm0 +`ass'm1+ `ass'm2

qui gen n`ass'q0_a = (`ass'pm2~=0) + (`ass'pm1~=0) + (`ass'm0~=0)
qui gen n`ass'q0_b = (`ass'pm1~=0) + (`ass'm0~=0) +(`ass'm1~=0)
qui gen n`ass'q0_c = (`ass'm0~=0) + (`ass'm1~=0)+ (`ass'm2~=0)

foreach j in a b c {
	qui gen ind_`ass'q0_`j' = (`ass'q0_`j'==`ass'q0)
	tab ind_`ass'q0_`j'  		if applcant==0&`ass'm0==0
	tab ind_`ass'q0_`j'  		if applcant==0&`ass'm0>0
	reg `ass'q0_`j' `ass'q0 	if applcant==0
}
qui gen ind_`ass'q0 = "a" 	if ind_`ass'q0_a==1
qui replace ind_`ass'q0 = ind_`ass'q0+";"+"b" if ind_`ass'q0_b==1&ind_`ass'q0~=""
qui replace ind_`ass'q0 = "b" if ind_`ass'q0_b==1&ind_`ass'q0==""
qui replace ind_`ass'q0 = ind_`ass'q0+";"+"c" if ind_`ass'q0_c==1&ind_`ass'q0~=""
qui replace ind_`ass'q0 = "c" if ind_`ass'q0_c==1&ind_`ass'q0==""
tab ind_`ass'q0 quarterRA 	if applcant==0, missing 

assert ind_`ass'q0~="c" if `ass'pq8==.
assert ind_`ass'q0~="a"&ind_`ass'q0~="b"&ind_`ass'q0~="a;b" if `ass'pq8~=.

qui gen finalqa = "c" if `ass'pq8~=. // this is for sure the RA-Q months {0,1,2}
qui replace finalqa = "b" if `ass'pq8==.&(ind_`ass'q0=="b"|ind_`ass'q0=="b;c") // this is for sure the RA-Q months {-1,0,1}
qui replace finalqa = "a" if `ass'pq8==.&(ind_`ass'q0=="a"|ind_`ass'q0=="a;c") // this is for sure the RA-Q months {-2,-1,0}
qui gen qfinalqa = 0 if finalqa~="" // quater on which we based the assignment of the methodology

tab finalqa ind_`ass'q0, missing









// let us generalize this to pin down the Q-RA for the cases when ind_`ass'q0 is a;b;c   or    a;c
pause on
local q=1
qui gen `ass'q`q'_a = `ass'm1 +`ass'm2 +`ass'm3
qui gen `ass'q`q'_b = `ass'm2 +`ass'm3 +`ass'm4
qui gen `ass'q`q'_c = `ass'm3 +`ass'm4 +`ass'm5
update_finalqa `q' `ass'

local q=2
qui gen `ass'q`q'_a = `ass'm4 +`ass'm5 +`ass'm6
qui gen `ass'q`q'_b = `ass'm5 +`ass'm6+`ass'm7
qui gen `ass'q`q'_c = `ass'm6+`ass'm7+`ass'm8
update_finalqa `q' `ass'

local q=3
qui gen `ass'q`q'_a = `ass'm7 +`ass'm8 +`ass'm9
qui gen `ass'q`q'_b = `ass'm8 +`ass'm9 +`ass'm10
qui gen `ass'q`q'_c = `ass'm9 +`ass'm10 +`ass'm11
update_finalqa `q' `ass'

local q=4
qui gen `ass'q`q'_a = `ass'm10 +`ass'm11 +`ass'm12
qui gen `ass'q`q'_b = `ass'm11 +`ass'm12 +`ass'm13
qui gen `ass'q`q'_c = `ass'm12 +`ass'm13 +`ass'm14
update_finalqa `q' `ass'

local q=5
qui gen `ass'q`q'_a = `ass'm13 +`ass'm14 +`ass'm15
qui gen `ass'q`q'_b = `ass'm14 +`ass'm15 +`ass'm16
qui gen `ass'q`q'_c = `ass'm15 +`ass'm16 +`ass'm17
update_finalqa `q' `ass'


local q=6
qui gen `ass'q`q'_a = `ass'm16 +`ass'm17 +`ass'm18
qui gen `ass'q`q'_b = `ass'm17 +`ass'm18 +`ass'm19
qui gen `ass'q`q'_c = `ass'm18 +`ass'm19 +`ass'm20
update_finalqa `q' `ass'


local q=7
qui gen `ass'q`q'_a = `ass'm19 +`ass'm20 +`ass'm21
qui gen `ass'q`q'_b = `ass'm20 +`ass'm21 +`ass'm22
qui gen `ass'q`q'_c = `ass'm21 +`ass'm22 +`ass'm23
update_finalqa `q' `ass'

local q=8
qui gen `ass'q`q'_a = `ass'm22 +`ass'm23 +`ass'm24
qui gen `ass'q`q'_b = `ass'm23 +`ass'm24 +`ass'm25
qui gen `ass'q`q'_c = `ass'm24 +`ass'm25 +`ass'm26
update_finalqa `q' `ass'

local q=9
qui gen `ass'q`q'_a = `ass'm25 +`ass'm26 +`ass'm27
qui gen `ass'q`q'_b = `ass'm26 +`ass'm27 +`ass'm28
qui gen `ass'q`q'_c = `ass'm27 +`ass'm28 +`ass'm29
update_finalqa `q' `ass'

local q=10
qui gen `ass'q`q'_a = `ass'm28 +`ass'm29 +`ass'm30
qui gen `ass'q`q'_b = `ass'm29 +`ass'm30 +`ass'm31
qui gen `ass'q`q'_c = `ass'm30 +`ass'm31 +`ass'm32
update_finalqa `q' `ass'

local q=11
qui gen `ass'q`q'_a = `ass'm31 +`ass'm32 +`ass'm33
qui gen `ass'q`q'_b = `ass'm32 +`ass'm33 +`ass'm34
qui gen `ass'q`q'_c = `ass'm33 +`ass'm34 +`ass'm35
update_finalqa `q' `ass'

local q=12
qui gen `ass'q`q'_a = `ass'm34 +`ass'm35 +`ass'm36
qui gen `ass'q`q'_b = `ass'm35 +`ass'm36 +`ass'm37
qui gen `ass'q`q'_c = `ass'm36 +`ass'm37 +`ass'm38
update_finalqa `q' `ass'

local q=13
qui gen `ass'q`q'_a = `ass'm37 +`ass'm38 +`ass'm39
qui gen `ass'q`q'_b = `ass'm38 +`ass'm39 +`ass'm40
qui gen `ass'q`q'_c = `ass'm39 +`ass'm40 +`ass'm41
update_finalqa `q' `ass'

local q=14
qui gen `ass'q`q'_a = `ass'm40 +`ass'm41 +`ass'm42
qui gen `ass'q`q'_b = `ass'm41 +`ass'm42 +`ass'm43
qui gen `ass'q`q'_c = `ass'm42 +`ass'm43 +`ass'm44
update_finalqa `q' `ass'

local q=15
qui gen `ass'q`q'_a = `ass'm43 +`ass'm44 +`ass'm45
qui gen `ass'q`q'_b = `ass'm44 +`ass'm45 +`ass'm46
qui gen `ass'q`q'_c = `ass'm45 +`ass'm46 +`ass'm47
update_finalqa `q' `ass'


local q=16
qui gen `ass'q`q'_a = `ass'm46 +`ass'm47 +`ass'm48
qui gen `ass'q`q'_b = `ass'm47 +`ass'm48 +`ass'm49
qui gen `ass'q`q'_c = `ass'm48 +`ass'm49 +`ass'm50
update_finalqa `q' `ass'


local q=17
qui gen `ass'q`q'_a = `ass'm49 +`ass'm50 +`ass'm51
qui gen `ass'q`q'_b = `ass'm50 +`ass'm51 +`ass'm52
qui gen `ass'q`q'_c = `ass'm51 +`ass'm52 +`ass'm53
update_finalqa `q' `ass'

local q=18
qui gen `ass'q`q'_a = `ass'm52 +`ass'm53 +`ass'm54
qui gen `ass'q`q'_b = `ass'm53 +`ass'm54 +`ass'm55
qui gen `ass'q`q'_c = `ass'm54 +`ass'm55 +`ass'm56
update_finalqa `q' `ass'


local q=19
qui gen `ass'q`q'_a = `ass'm55 +`ass'm56 +`ass'm57
qui gen `ass'q`q'_b = `ass'm56 +`ass'm57 +`ass'm58
qui gen `ass'q`q'_c = `ass'm57 +`ass'm58 +`ass'm59
update_finalqa `q' `ass'

local q=20
qui gen `ass'q`q'_a = `ass'm58 +`ass'm59 +`ass'm60
qui gen `ass'q`q'_b = `ass'm59 +`ass'm60 +`ass'm61
qui gen `ass'q`q'_c = `ass'm60 +`ass'm61 +`ass'm62
update_finalqa `q' `ass'

local q=21
qui gen `ass'q`q'_a = `ass'm61 +`ass'm62 +`ass'm63
qui gen `ass'q`q'_b = `ass'm62 +`ass'm63 +`ass'm64
qui gen `ass'q`q'_c = `ass'm63 +`ass'm63 +`ass'm65
update_finalqa `q' `ass'

// we start using also prior to RA
local pq = 1
qui gen `ass'q`pq'_a = `ass'pm5 +`ass'pm4 +`ass'pm3
qui gen `ass'q`pq'_b = `ass'pm4 +`ass'pm3 +`ass'pm2
qui gen `ass'q`pq'_c = `ass'pm3 +`ass'pm2 +`ass'pm1
update_finalqa_v2 `pq' `ass'

local pq = 2
qui gen `ass'q`pq'_a = `ass'pm8 +`ass'pm7 +`ass'pm6
qui gen `ass'q`pq'_b = `ass'pm7 +`ass'pm6 +`ass'pm5
qui gen `ass'q`pq'_c = `ass'pm6 +`ass'pm5 +`ass'pm4
update_finalqa_v2 `pq' `ass'

local pq = 3
qui gen `ass'q`pq'_a = `ass'pm11 +`ass'pm10 +`ass'pm9
qui gen `ass'q`pq'_b = `ass'pm10 +`ass'pm9 +`ass'pm8
qui gen `ass'q`pq'_c = `ass'pm9 +`ass'pm8 +`ass'pm7
update_finalqa_v2 `pq' `ass'


local pq = 4
qui gen `ass'q`pq'_a = `ass'pm14 +`ass'pm13 +`ass'pm12
qui gen `ass'q`pq'_b = `ass'pm13 +`ass'pm12 +`ass'pm11
qui gen `ass'q`pq'_c = `ass'pm12 +`ass'pm11 +`ass'pm10
update_finalqa_v2 `pq' `ass'

local pq = 5
qui gen `ass'q`pq'_a = `ass'pm17 +`ass'pm16 +`ass'pm15
qui gen `ass'q`pq'_b = `ass'pm16 +`ass'pm15 +`ass'pm14
qui gen `ass'q`pq'_c = `ass'pm15 +`ass'pm14 +`ass'pm13
update_finalqa_v2 `pq' `ass'

local pq = 6
qui gen `ass'q`pq'_a = `ass'pm20 +`ass'pm19 +`ass'pm18
qui gen `ass'q`pq'_b = `ass'pm19 +`ass'pm18 +`ass'pm17
qui gen `ass'q`pq'_c = `ass'pm18 +`ass'pm17 +`ass'pm16
update_finalqa_v2 `pq' `ass'

local pq = 7
qui gen `ass'q`pq'_a = `ass'pm23 +`ass'pm22 +`ass'pm21
qui gen `ass'q`pq'_b = `ass'pm22 +`ass'pm21 +`ass'pm20
qui gen `ass'q`pq'_c = `ass'pm21 +`ass'pm20 +`ass'pm19
update_finalqa_v2 `pq' `ass'



rename finalqa finalqa_basedonFS
rename qfinalqa qfinalqa_basedonFS
tab finalqa_basedonFS qfinalqa_basedonFS,  missing
tab finalqa_basedonFS finalqa_basedonAFDC,  missing


assert finalqa_basedonFS==finalqa_basedonAFDC if finalqa_basedonFS~=""&finalqa_basedonAFDC~="" // they agree!!
qui gen finalqa = finalqa_basedonAFDC
qui replace finalqa = finalqa_basedonFS if finalqa_basedonAFDC==""&finalqa_basedonFS~=""
drop finalqa_basedonFS
drop finalqa_basedonAFDC


// who are those for whom we cannot pin down the methodology?
// 40 units and the vast majority are such that they were never recipients of either AFDC or FS,
// that is the reason why we cannot pin them down. We randomly assign a quarter of RA to them.
if 1==0 {
	preserve
		qui keep if finalqa==""
		keep adcpm* adcm* fstpm* fstm* pufid ind_adcq_prior* ind_adcq_post* ind_fstq_prior* ind_fstq_post*
		sort pufid
		by pufid: list ind_adcq_prior* ind_adcq_post* ind_fstq_prior* ind_fstq_post*, ab(30)
		foreach var of varlist adcpm* adcm* fstpm* fstm* {
			qui count if `var'~=0&`var'~=.
			local n = r(N)
			if `n'==0 {
				di "Units with zero amount in `var' = All"
			}
			else {
				di "Units with zero amount in `var' = " `n'
			}
		}
	restore
}
set seed 123456789
qui gen randomq = runiform()
qui replace finalqa = "b" if finalqa==""&randomq<0.5
qui replace finalqa = "a" if finalqa==""&randomq>=0.5
assert finalqa~=""
qui gen monthsinQ0 = 1 if finalqa=="a"
qui replace monthsinQ0 = 2 if finalqa=="b"
qui replace monthsinQ0 = 3 if finalqa=="c"
label define monthsinQ0_lbl 1 "{-2,-1,0}" 2 "-1,0,1" 3 "0,1,2"
label values monthsinQ0 monthsinQ0_lbl

drop finalqa
drop ind_adcq_prior* ind_adcq_post* ind_fstq_prior* ind_fstq_post*
drop *_a
drop *_b
drop *_c










